set @admin_nick='HubAdmin';
set @admin_pass='AdminPass';

create table if not exists banlist (
	ip         varchar(15)  NULL default NULL,
	nick       varchar(60)  NULL default NULL,
	host       text         NULL default NULL,
	share_size varchar(15)  NULL default NULL,
	email      varchar(128) NULL default NULL,
	range_fr   varchar(15)  NULL default NULL,
	range_to   varchar(15)  NULL default NULL,
	date_start datetime     NULL default 0,
	date_limit datetime     NULL default NULL,
	flags      SET('A','I','N','H','S','E','R') NOT NULL default 'A',
	nick_op    varchar(60)  NULL default NULL,
	reason     text         NULL default NULL,
	UNIQUE (ip,nick),
	index ban_index (ip,nick,flags)
);

create table if not exists allowlist (
	ip         varchar(15)  NULL default NULL,
	nick       varchar(60)  NULL default NULL,
	host       text         NULL default NULL,
	share_size varchar(15)  NULL default NULL,
	email      varchar(128) NULL default NULL,
	range_fr   varchar(15)  NULL default NULL,
	range_to   varchar(15)  NULL default NULL,
	date_start datetime     NULL default 0,
	date_limit datetime     NULL default NULL,
	flags      SET('A','I','N','H','S','E','R') NOT NULL default 'A',
	nick_op    varchar(60)  NULL default NULL,
	reason     text         NULL default NULL,
	UNIQUE key (ip,nick),
	index ban_index (ip,nick,flags)
);

CREATE TABLE IF NOT EXISTS reglist (
	nick        varchar(60) NOT NULL PRIMARY KEY, 
	class       int(2)      NOT NULL default 1, 
	reg_date    datetime    NOT NULL ,
	reg_op      varchar(60) NOT NULL default 'sys_admin',
	login_pwd   varchar(60) NULL default NULL, 
	login_last  datetime    default 0,
	login_count int(11)     default 0,
	login_ip    varchar(16) , 
	error_last  datetime    , 
	error_cnt   int(11)     default 0, 
	error_ip    varchar(16) , 
	enabled     bool        default 1,
	flags       SET('disabled','pwd_crypt','pwd_change','mail_val') NOT NULL
		default 'pwd_change',
	rights      SET('settings') NULL default NULL,
	restr       SET('search','chat') NULL default NULL,
	settings    SET('hide_kicks','stealth_op') NULL default NULL,
	protect     SET('kick','redir') null default NULL,
	pr_from     integer default 4,
	pr_reason   text NULL default NULL,
	pr_op       varchar(60) NULL default NULL,
	email       varchar(128) NULL default NULL, 
	man_ip      varchar(16) NULL default NULL,
	note        text        NULL default NULL
);

INSERT IGNORE INTO reglist (nick, class, login_pwd, reg_date) VALUES
	(@admin_nick, 10, @admin_pass, now() );

CREATE TABLE IF NOT EXISTS kicklist (
	nick       varchar(60) NOT NULL, 
	date_kick  datetime NOT NULL, 
	ip         varchar(15) NOT NULL, 
	nick_op    varchar(60) NOT NULL, 
	reason     text NULL default NULL,
	status     SET ('drop', 'message') NOT NULL default '', 
	PRIMARY KEY ( nick, date_kick )
);

CREATE TABLE IF NOT EXISTS nick_prefix (
	prefix      varchar(15) NOT NULL PRIMARY KEY,
	allow_min   integer default 0,
	allow_max   integer default 10,
	must_min    integer NULL default 0 ,
	must_max    integer NULL default -1,
	note        text NULL default NULL
);

INSERT IGNORE INTO nick_prefix (prefix, allow_min,note) VALUES
	('[OP]',3,'only for operators'),
	('[VIP]',2,'only for vip users'),
	('[REG]',1,'only for registered users'),
	('Verli',10,'reserved for hub soft creator Verliba'),
	('Hub-',10,'reserved for hub purposes');

CREATE TABLE IF NOT EXISTS file_trigger (
	command     varchar(20) NOT NULL PRIMARY KEY,
	send_as     varchar(20) NULL default NULL,
	flags       SET('exe') NULL default NULL,
	def         text NOT NULL,
	descr       text NULL default NULL,
	min_class   integer default 0,
	trunc_ln    integer NULL default NULL,
	trunc_len   integer NULL default NULL,
	delay_usr   integer NULL default NULL,
	delay_tot   integer NULL default NULL
);

INSERT IGNORE INTO file_trigger (command , def, descr) VALUES
	('+motd','.verlihub/motd','the wellcome message'),
	('+rules','.verlihub/rules','Hub rules'),
	('+faq','.verlihub/faq','Frequently asked questions');

CREATE TABLE IF NOT EXISTS speedlist (
	host   varchar(128) NULL default NULL,
	subnet varchar(15) NULL default NULL,
	ipr_lo varchar(15) NULL default NULL,
	ipr_hi varchar(15) NULL default NULL,
	speed  varchar(15) NOT NULL,
	note   text NULL default NULL
);

CREATE TABLE IF NOT EXISTS protectlist (
	nick       varchar(60) NOT NULL PRIMARY KEY,
	against    SET('kick','redir') default 'kick',
	from_cl    integer default 4,
	date_start datetime,
	date_limit datetime NULL default NULL,
);
