/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef NDIRECTCONNECTCBAN_H
#define NDIRECTCONNECTCBAN_H

#include <cobj.h>

namespace nDirectConnect {

/**
a ban record structure

@author Daniel Muller
*/
class cBan : public cObj
{
public:
	cBan();
	~cBan();

	// banned ip address
	string mIP;
	// banned nick
	string mNick;
	// banned host name
	string mHost;
	// banned share size
	string mShare;
	// banned mail
	string mMail;
	// banned ip range
	string mRangeMin;
	string mRangeMax;
	// unix timestamp of the start, end
	unsigned mDateStart;
	unsigned mDateEnd;
	// ban flags
	enum
	{
		eBF_ACTIVE,
		eBF_IP,
		eBF_NICK,
		eBF_HOST,
		eBF_SHARE,
		eBF_EMAIL,
		eBF_RANGE
	};
	int mFlags;
	// op banner
	string mNickOp;
	// the ban reason
	string mReason;

/*
create table if not exists banlist (
        ip         varchar(15)  NULL default NULL,
        nick       varchar(60)  NULL default NULL,
        host       text         NULL default NULL,
        share_size varchar(15)  NULL default NULL,
        email      varchar(128) NULL default NULL,
        range_fr   varchar(15)  NULL default NULL,
        range_to   varchar(15)  NULL default NULL,
        date_start datetime     NULL default 0,
        date_limit datetime     NULL default NULL,
        flags      SET('A','I','N','H','S','E','R') NOT NULL default 'A',
        nick_op    varchar(60)  NULL default NULL,
        reason     text         NULL default NULL,
        UNIQUE (ip,nick),
        index ban_index (ip,nick,flags)
);

*/

};

};

#endif
