/***************************************************************************
                          cconfigbase.cpp  -  description
                             -------------------
    begin                : Sun Jun 15 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cconfigbase.h"

namespace nConfig
{

cConfigBase::cConfigBase() : cObj("cConfigBase")
{
	mBasePtr= NULL;
}

cConfigBase::~cConfigBase()
{
}

// cConfigItemBase & cConfigBase::Add(string n, void *a, tItemType t, int s)
// {
// 	return mItems[n].Bind(a,t,s);
// }

/** add existing item pointed by the argument at the end of mvItems */
cConfigItemBase * cConfigBase::Add(cConfigItemBase *ci)
{
	if(ci) mvItems.push_back(ci);
	return ci;
}

/** add existing item pointed by the argument at the end of mvItems , and bind a nick to it*/
cConfigItemBase * cConfigBase::Add(const string &nick, cConfigItemBase *ci)
{
	mhItems[nick]=ci;
	return Add(ci);
}

/** bind a nick to a given vaiable */
void cConfigBase::BindNick(int i, const string &nick)
{
	mhItems[nick]=mvItems[i];
}

/** access operators */
cConfigItemBase * cConfigBase::operator[](int i)
{
	return mvItems[i];
}
cConfigItemBase * cConfigBase::operator[](const string &n)
{
	tIHIt it=mhItems.find(n);
	if(it != mhItems.end()) return it->second;
	return NULL;
}

const cConfigItemBase * cConfigBase::operator[](int i) const
{
	return mvItems[i];
}

void cConfigBase::SetBaseTo(void * new_base)
{
	if(mBasePtr)
	{
		for(tIVIt it = mvItems.begin(); it != mvItems.end(); it++ )
			(*it)->mAddr = (void*)(long((*it)->mAddr) + (long(new_base)-long(mBasePtr)));
	}
	mBasePtr = new_base;
}

};
