/***************************************************************************
                          cconfigfile.cpp  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cconfigfile.h"
#include <fstream>
#include <sstream>

namespace nConfig
{

/*
 	to be used in a following way..
	* add as many fields as nedded, all binded to some physical locations and refering to the types
	* variable given by the name can be found and loaded using a >> operator (virtual template)
	* variable can be also outputed by the << operator
*/

cConfigFile::cConfigFile(const string &file): mFile(file)
{
}
cConfigFile::~cConfigFile(){
}

/** The config load function - from a file */
int cConfigFile::Load()
{
	ifstream is(mFile.data());
	if(!is.is_open()) return 0;
	string name;
	string str;
	istringstream *ss;
	cConfigItemBase *ci;
	char ch;

	while(!is.eof())
	{
		ch = ' ';
		is >> name;
		is >> ch >> ws;
		if( ch == ' ' ) break;
		getline(is,str);
		if( ch != '=' ) break;
		if( ci = operator[](name) )
		{
			ss = new istringstream();
			ss->str(str);
			ss->seekg(0,istream::beg);
			(*ss) >> *ci;
			delete ss;
		}
		else
			cout << "Uknown variable '" << name << "' in file '" << mFile << "', ignoring it" << endl;
	}
	is.close();
	return 0;
}

// istream & operator >> (istream &is , cConfigFile::cConfigItem &ci)
// {
// 	string str, str2;
// 	switch(ci.mType)
// 	{
// 		case eIT_INT: is >> *((int*) ci.mAddr); break;
// 		case eIT_UINT: is >> *((unsigned*) ci.mAddr); break;
// 		case eIT_LONG: is >> *((long*) ci.mAddr); break;
// 		case eIT_ULONG: is >> *((unsigned long*) ci.mAddr); break;
// 		case eIT_LLONG: is >> *((long long*) ci.mAddr); break;
// 		case eIT_ULLONG: is >> *((unsigned long long*) ci.mAddr); break;
// 		case eIT_STRING:
// 			is >> str2 >> str;
// 			for(  ; str.size() && (str[0] != '#') ;is >> str )
// 			{
// 				str2 += ' ';
// 				str2 += str;
// 				str = "";
// 			}
// 			*((string*) ci.mAddr) = str2;
// 			break;
// 		case eIT_NTSTR:
// 			for( is >> str2 >> str ; str.size() && (str[0] != '#') ;is >> str )
// 			{
// 				str2 += ' ';
// 				str2 += str;
// 			}
// 			if(ci.mAddr) delete (char *)ci.mAddr;
// 			ci.mAddr = new char[str2.size()+1];
// 			strcpy((char*)ci.mAddr, str2.data());
// 			break;
// 		default: break;
// 	}
// 	return is;
// }
//
// ostream & operator << (ostream &os , cConfigFile::cConfigItem &ci)
// {
// 	string str, str2;
// 	switch(ci.mType)
// 	{
// 		case eIT_INT: os << *((int*) ci.mAddr); break;
// 		case eIT_UINT: os << *((unsigned*) ci.mAddr); break;
// 		case eIT_LONG: os << *((long*) ci.mAddr); break;
// 		case eIT_ULONG: os << *((unsigned long*) ci.mAddr); break;
// 		case eIT_LLONG: os << *((long long*) ci.mAddr); break;
// 		case eIT_ULLONG: os << *((unsigned long long*) ci.mAddr); break;
// 		case eIT_STRING: os << *((string *) ci.mAddr); break;
// 		case eIT_NTSTR: os << ((char *) ci.mAddr); break;
// 		default: break;
// 	}
// 	return os;
// }

/** save config, to be able to load it after */
int cConfigFile::Save()
{
	return 0;
}

};

