/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "cconfigitembase.h"
#include <stdlib.h>
#include <iostream>

using namespace std;

namespace nConfig
{

// special instatntioations of the converion from string
void cConfigItemBaseT<int>		::ConvertFrom(const std::string &str){*this = atoi(str.data());}
void cConfigItemBaseT<unsigned int>	::ConvertFrom(const std::string &str){*this = atoi(str.data());}
void cConfigItemBaseT<long>		::ConvertFrom(const std::string &str){*this = atol(str.data());}
void cConfigItemBaseT<unsigned long>	::ConvertFrom(const std::string &str){*this = atol(str.data());}
void cConfigItemBaseT<long long>	::ConvertFrom(const std::string &str){*this = atoll(str.data());}
void cConfigItemBaseT<unsigned long long>::ConvertFrom(const std::string &str){*this = atoll(str.data());}
void cConfigItemBaseT<double>		::ConvertFrom(const std::string &str){*this = atof(str.data());}
void cConfigItemBaseT<char>		::ConvertFrom(const std::string &str){*this = *str.data();}
void cConfigItemBaseT<unsigned char>	::ConvertFrom(const std::string &str){*this = *str.data();}
void cConfigItemBaseT<const char *>	::ConvertFrom(const std::string &str){*this = str.data();}
void cConfigItemBaseT<std::string>	::ConvertFrom(const std::string &str){*this = str;}
void cConfigItemBaseT<char *>		::ConvertFrom(const std::string &str)
{
	char *data = (char*)(*this) ;
	if( data ) delete data;
	data = new char[str.size()+1];
	memcpy(data,str.data(),str.size()+1);
	*this = data;
}

istream &cConfigItemBaseT<std::string>::ReadFromStream(istream& is)
{
	string str;
	Data() = "";
	is >> Data() >> str;
	for(  ; str.size() && (str[0] != '#') ;is >> str )
	{
		Data() += ' ';
		Data() += str;
		str = "";
	}
	return is ;
}

};