/***************************************************************************
                          cdcbanlist.cpp  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdcbanlist.h"
#include "cconndc.h"
#include "ckick.h"
#include <fstream>

using namespace std;

namespace nDirectConnect
{

cDCBanList::cDCBanList(cServerDC &serv,const string &filename):mFileName(filename),mS(serv)
{
}

cDCBanList::~cDCBanList()
{
}

/** search for address, return NULL if not found */
//cDCBanRecord * cDCBanList::SearchAddr(const string &addr,const string &addr2, bool rem, bool all)
//{
//	ifstream is(mFileName.data());
//	ofstream os;
//	cDCBanRecord *ret=NULL,*br=new cDCBanRecord;
//	if(!is.is_open()) return NULL;
//	string swap="./.verlihub/.banlist.temp";
//	bool match=false;
//
//	if(rem)
//	{
//		os.open(swap.data(),ios::out|ios::trunc);
//		if(!os.is_open()) rem=false;
//	}
//
//	while(!is.eof())
//	{
//		is >> *br;
//		if(is.eof()) break;
//
//		if(!br->mAddr.size()) break;
//
//		if(
//			(!match || all) &&
//			(
//				(br->mAddr == addr) ||
//				(br->mAddr == addr2)
//			)
//		)
//		{
//			if(!rem)
//			{
//				is.close();
//				return br;
//			}
//			else if(!match)
//			{
//				ret=br;
//				br=new cDCBanRecord;
//			}
//			match = true;
//		}
//		else if(rem) os << *br;
//	}
//	is.close();
//	if(rem)
//	{
//		os.close();
//		::remove(mFileName.data());
//		::rename(swap.data(), mFileName.data());
//	}
//	delete br;
//	return ret;
//}

/** remove given ban from the list, if possible */
int cDCBanList::RemoveBan(const string &ip, const string &nick, const string &host, int method)
{
	ostringstream os;
	int n=0;
	if(method & eBT_IP)
	{
		os.str(mS.mEmpty);
		os << "DELETE FROM ipbanlist WHERE ip ='" << ip << "'";
		if(mysql_query(&mS.db_handle, os.str().data()))
		{
			cout << os.str() << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		}
		n += mysql_affected_rows(&mS.db_handle);
	}
	
	if(method & eBT_NICK)
	{
		os.str(mS.mEmpty);
		os << "DELETE FROM nickbanlist WHERE ";
		if(ip.size())
		{
			os << " ip ='" << ip << "' ";
		  if(nick.size()) os << " OR ";
		}
		if(nick.size()) os << " LOWER(nick) =LOWER('" << nick << "') ";
		if(mysql_query(&mS.db_handle, os.str().data()))
		{
			cout << os.str() << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		}
		n += mysql_affected_rows(&mS.db_handle);
	}
	
	if(method & eBT_HOST)
	{
		os.str(mS.mEmpty);
		os << "DELETE FROM hostbanlist WHERE host ='" << host << "'";
		if(mysql_query(&mS.db_handle, os.str().data()))
		{
			cout << os.str() << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		}
		n += mysql_affected_rows(&mS.db_handle);
	}
	return n;
}

///** add ban entry ; return 1 when aded, 0 if already exists, -1 on error */
//int cDCBanList::AddBan(const string &ip_host,time_t limit, cConnDC *op, const string &code, const string &nick)
//{
//	cDCBanRecord br;
//	br.mAddr = ip_host;
//	br.mCode=code;
//	br.mStart=time(NULL);
//	br.mEnd=limit;
//	if(op && op->mpUser) br.mOp = op->mpUser->mNick;
//	br.mNick=nick;
//
///*	cDCBanRecord * rb = SearchAddr(ip_host,ip_host,false);
//	if(rb)
//	{
//		delete rb;
//		return 0;
//	}
//*/
//
//	// write it in
//	ofstream os(mFileName.data(),ios::app|ios::out);
//	if(!os.is_open()) return -1;
//	os << br;
//	os.close();
//	return 1;
//}

/** creates empty table in database if not exists */
int cDCBanList::CreateTable()
{
	string query;
	query = "CREATE TABLE IF NOT EXISTS ipbanlist (";
	query+= "ip varchar(15) NOT NULL PRIMARY KEY, ";
	query+= "date_ban datetime NOT NULL, ";
	query+= "date_limit datetime, ";
	query+= "nick_ban varchar(60) NOT NULL, ";
	query+= "nick_op varchar(60) NOT NULL, ";
	query+= "reason text ";
	query+= ")";

	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}

	query = "CREATE TABLE IF NOT EXISTS hostbanlist (";
	query+= "host varchar(128) NOT NULL PRIMARY KEY, ";
	query+= "ip varchar(15), "; // link to the ipbanlist table
	query+= "date_ban datetime NOT NULL, ";
	query+= "date_limit datetime, "; // NULL means permanent
	query+= "nick_ban varchar(60), ";
	query+= "nick_op varchar(60) NOT NULL, ";
	query+= "reason text ";
	query+= ")";

	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}

	query = "CREATE TABLE IF NOT EXISTS nickbanlist (";
	query+= "nick varchar(60) NOT NULL PRIMARY KEY, ";
	query+= "ip varchar(15), "; // link to the ipbanlist table
	query+= "date_ban datetime NOT NULL, ";
	query+= "date_limit datetime, "; // NULL means permanent
	query+= "nick_op varchar(60) NOT NULL, ";
	query+= "reason text ";
	query+= ")";

	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}

	query = "CREATE TABLE IF NOT EXISTS kicklist (";
	query+= "nick varchar(60) NOT NULL , ";
	query+= "date_kick datetime NOT NULL, ";
	query+= "ip varchar(15), "; // link to the ipbanlist table
	query+= "nick_op varchar(60) NOT NULL, ";
	query+= "reason text, ";
	query+= "status SET ('drop', 'message') , ";
	query+= "banned SET ('ip','nick','host'), ";
	query+= "PRIMARY KEY( nick, date_kick ))";

	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}

	query = "CREATE TABLE IF NOT EXISTS nickreserved (";
	query+= "nick varchar(60) NOT NULL PRIMARY KEY) ";
	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}
	query = "INSERT IGNORE INTO nickreserved VALUES ('VerliHub'),('Hub-Security')";
	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}
	return 0;
}

/** No descriptions */
int cDCBanList::FindBan(cConnDC *conn, cDCBanRecord &br)
{
	string empty;
	string limit= " (date_limit IS NULL OR (date_limit >= NOW()))";
	ostringstream query;
	MYSQL_RES *result;
	MYSQL_ROW row;
	int row_count;

	br.mBanType =0;
	
	//////////////// ip or subnet ban
	
	query << "SELECT ip, UNIX_TIMESTAMP(date_ban), UNIX_TIMESTAMP(date_limit), nick_ban, nick_op, "
		<< "reason, UNIX_TIMESTAMP(date_limit)-UNIX_TIMESTAMP(NOW()) FROM ipbanlist"
		<< " WHERE (('" << conn->AddrIP() << "'= ip OR "
		<< " ((LEFT('" << conn->AddrIP() << "', LENGTH(ip)+1) = CONCAT(ip,'.')))) AND" << limit << ")";

	if(conn->Log(5)) conn->LogStream() << query.str() << endl;
	// call query
	if(mysql_query(&mS.db_handle, query.str().data()))
	{
		cout << query.str() << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		return 0;
	}
	result = mysql_store_result(&mS.db_handle);
	row_count= mysql_num_rows(result);

	if(row_count)
	{
		// fetch a row
		row = mysql_fetch_row(result);

		// fill in structure
		br.mAddr  = row[0] ? row[0] : "";
		br.mStart = row[1] ? atoi(row[1]) : 0;
		br.mEnd   = row[2] ? atoi(row[2]) : 0;
		br.mNick  = row[3] ? row[3] : "";
		br.mOp    = row[4] ? row[4] : "";
		br.mReason= row[5] ? row[5] : "";
		br.mTimeRest= row[6] ? atol(row[6]) : 0;
		
		br.mBanType = (conn->AddrIP() == br.mAddr)?1:2;
	}
	
	mysql_free_result(result);

	//////////////// host ban
	
	if(!row_count)
	{
		query.str(empty);
		query << "SELECT host, UNIX_TIMESTAMP(date_ban), UNIX_TIMESTAMP(date_limit), nick_ban, nick_op, "
			<< "reason, UNIX_TIMESTAMP(date_limit)-UNIX_TIMESTAMP(NOW()) FROM hostbanlist"
			<< " WHERE ((RIGHT('" << conn->AddrHost() << "', LENGTH(ip)) = ip) AND" << limit << ")";
		if(mysql_query(&mS.db_handle, query.str().data()))
		{
			cout << query.str() << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			return 0;
		}

		result = mysql_store_result(&mS.db_handle);
		row_count= mysql_num_rows(result);

		if(row_count)
		{
			// fetch a row
			row = mysql_fetch_row(result);
			// fill in structure
			br.mAddr  = row[0] ? row[0] : "";
			br.mStart = row[1] ? atoi(row[1]) : 0;
			br.mEnd   = row[2] ? atoi(row[2]) : 0;
			br.mNick  = row[3] ? row[3] : "";
			br.mOp    = row[4] ? row[4] : "";
			br.mReason= row[5] ? row[5] : "";
			br.mTimeRest= row[6] ? atol(row[6]) : 0;

			br.mBanType = 3;
		}

		mysql_free_result(result);

	}
	
	if(!row_count)
	{
		query.str(empty);
		query << "SELECT ip, nick, UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP(date_kick), "
			<< "nick_op, reason FROM kicklist "
			<< "WHERE UNIX_TIMESTAMP(date_kick) >= UNIX_TIMESTAMP(NOW()) - "
			<< mS.mC.tban_kick
			<< " AND FIND_IN_SET('drop',status) > 0 "
			<< " AND ip='" << conn->AddrIP() << "' ORDER BY date_kick DESC LIMIT 1";
		if(mysql_query(&mS.db_handle, query.str().data()))
		{
			cout << query.str() << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			return 0;
		}

		result = mysql_store_result(&mS.db_handle);
		row_count= mysql_num_rows(result);

		if(row_count)
		{
			// fetch a row
			row = mysql_fetch_row(result);
			// fill in structure
			br.mBanType = 6; // kick
			br.mAddr  = row[0] ? row[0] : "";
			br.mNick  = row[1] ? row[1] : "";
			br.mTimeRest= row[2] ? mS.mC.tban_kick - atol(row[2]) : 0;
			br.mOp    = row[3] ? row[3] : "";
			br.mReason= row[4] ? row[4] : "";
		}

		mysql_free_result(result);
		
	}

	return row_count;
}

/** No descriptions */
int cDCBanList::FindBan(const string &nick, cDCBanRecord &br)
{
	string limit= " (date_limit IS NULL OR (date_limit >= NOW()))";
	ostringstream query;
	MYSQL_RES *result;
	MYSQL_ROW row;
	int row_count;
	br.mBanType = 0;

	//////////////// ip or subnet ban

	query << "SELECT ip, UNIX_TIMESTAMP(date_ban), UNIX_TIMESTAMP(date_limit), nick, nick_op, reason, "
		<< "UNIX_TIMESTAMP(date_limit)-UNIX_TIMESTAMP(NOW()) FROM nickbanlist"
		<< " WHERE LOWER(nick) =LOWER('" << nick << "') AND" << limit ;

	//cout << query.str() << endl;
	// call query
	if(mysql_query(&mS.db_handle, query.str().data()))
	{
		cout << query.str() << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		return 0;
	}
	result = mysql_store_result(&mS.db_handle);
	row_count= mysql_num_rows(result);

	if(row_count)
	{

		// fetch a row
		row = mysql_fetch_row(result);

		// fill in structure
		br.mAddr  = row[0] ? row[0] : "";
		br.mStart = row[1] ? atoi(row[1]) : 0;
		br.mEnd   = row[2] ? atoi(row[2]) : 0;
		br.mNick  = row[3] ? row[3] : "";
		br.mOp    = row[4] ? row[4] : "";
		br.mReason= row[5] ? row[5] : "";
		br.mTimeRest= row[6] ? atol(row[6]) : 0;

		br.mBanType = 5;
	}

	mysql_free_result(result);
	return row_count;
}


/**
	HOW BANNING WORKS:
	------------------

	1) banned can be:
	--------------
	a) ip
	b) ip subnet (A/B/C)
	c) host / domain ...
	d) nick
	e) share size (blind disconnect)

	2) bans can be permanent or temporary

	3) ip ban doesn't work on registered users, but nick ban does, and there is a flag in registration

	4) only admin can ban ip range
	5) ops can ban only someone who is online, and with a reason, and time period

	6) there are 3 ways of banning
  -----
	a) by the command and writing everything ...
	b) through the kick with a keyword
	c) through a protocol (new feature of czdc++)

	7) ban command bans everythink that it can,
		- something may have been banned already, overrides longer ban
		-
	
*/

/** removes old bans from banlists, and moves them to another table */
int cDCBanList::RemoveOldBans()
{
	string query;
	string where = "WHERE date_limit < NOW()";
	
	query = "INSERT INTO ipbanlist_old SELECT * FROM ipbanlist ";
	query+= where;
	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}
	query = "DELETE FROM ipbanlist ";
	query+= where;
	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}
	
	query = "INSERT INTO hostbanlist_old SELECT * FROM hostbanlist ";
	query+= where;
	if(mysql_query(&mS.db_handle, query.data()))
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	query = "DELETE FROM hostbanlist ";
	query+= where;
	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
	}
	return 0;
}

/** add ban entry, ban conn, by op, for t seconds (0=perm), with reason, and user methods */
int cDCBanList::AddBan(const string &ip, const string &nick , const string &host ,cConnDC *op , time_t t,  const string &reason , int methods, bool force)
{
	string query, table, values;
	ostringstream os;

	if(ip.size()) os << "'" << ip << "', ";
	else os << "NULL, ";
	os << "NOW(), ";
	if(t) os <<	"FROM_UNIXTIME(UNIX_TIMESTAMP(NOW())+" << t << "), ";
	else  os << "NULL, ";
	if(nick.size()) os << "'" << nick << "', ";
	else os << "NULL, ";
	if(op) os << "'" << op->mpUser->mNick << "', ";
	else   os << "'VerliHub', ";
	os << "\"" << reason << "\"";

	query = "DELETE FROM ipbanlist WHERE date_limit < NOW()";
	mysql_query(&mS.db_handle, query.data());
	query = "DELETE FROM hostbanlist WHERE date_limit < NOW()";
	mysql_query(&mS.db_handle, query.data());
	query = "DELETE FROM nickbanlist WHERE date_limit < NOW()";
	mysql_query(&mS.db_handle, query.data());

	if(methods & eBT_IP)
	{
		if(force)
		{
			query ="DELETE FROM ipbanlist WHERE ip='";
			query+=ip;
			query+="'";
			if(mysql_query(&mS.db_handle, query.data()))
			{
				cout << query << endl;
				cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			}
		}
		
		query = "INSERT INTO ";
		table = "ipbanlist (ip, date_ban, date_limit, nick_ban, nick_op, reason) ";
		query+= table;
		query+= "VALUES (";
		query+=os.str();
		query+= ")";
		if(mysql_query(&mS.db_handle, query.data()))
		{
			cout << query << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			methods ^= eBT_IP;
		}
	}

	if(methods & eBT_HOST)
	{
		if(force)
		{
			query ="DELETE FROM hostbanlist WHERE host='";
			query+=host;
			query+="'";
			if(mysql_query(&mS.db_handle, query.data()))
			{
				cout << query << endl;
				cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			}
		}

		query = "INSERT INTO ";
		table = "hostbanlist (host, ip, date_ban, date_limit, nick_ban, nick_op, reason) ";
		query+= table;
		query+= "VALUES (";
		query+= "'";
		query+= host;
		query+= "', ";
		query+=os.str();
		query+= ")";
		if(mysql_query(&mS.db_handle, query.data()))
		{
			cout << query << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			methods ^= eBT_HOST;
		}
	}

	if(methods & eBT_NICK)
	{
		if(force)
		{
			query ="DELETE FROM nickbanlist WHERE LOWER(nick)=LOWER('";
			query+=nick;
			query+="')";
			if(mysql_query(&mS.db_handle, query.data()))
			{
				cout << query << endl;
				cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			}
		}
		query = "INSERT INTO ";
		table = "nickbanlist (ip, date_ban, date_limit, nick, nick_op, reason) ";
		query+= table;
		query+= "VALUES (";
		query+=os.str();
		query+= ")";
		if(mysql_query(&mS.db_handle, query.data()))
		{
			cout << query << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			methods ^= eBT_NICK;
		}
	}
	
	return methods;	
}

/** ads kick into a database */
int cDCBanList::AddKick(cConnDC *conn,cConnDC *op, const string *reason)
{
	MYSQL_RES *res;
	MYSQL_ROW row;
	int row_count;
	string date,nick;
	string empty;
	ostringstream os;
	
	// first select if something is there
	os << "SELECT nick, UNIX_TIMESTAMP(date_kick) FROM kicklist WHERE date_kick > NOW()-300 AND nick ='";
	os << conn->mpUser->mNick << "' ";
	if(reason) os <<" AND FIND_IN_SET('message',status) = 0 ";
	else os <<" AND FIND_IN_SET('drop',status) = 0 ";
	os <<" ORDER BY date_kick DESC LIMIT 1";

	if(mysql_query(&mS.db_handle, os.str().data()))
	{
		cout << os.str() << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		return -1;
	}
	res = mysql_store_result(&mS.db_handle);
	row_count= mysql_num_rows(res);
	if(row_count)
	{
		row = mysql_fetch_row(res);
		// record found, update
		if(!reason)
		{
			os.str(empty);
			os << "UPDATE kicklist SET status = CONCAT(status, ',drop') WHERE nick='"
				 << row[0] << "' AND UNIX_TIMESTAMP(date_kick)=" << row[1];
		}else
		{
			os.str(empty);
			os << "UPDATE kicklist SET status = CONCAT(status, ',message'), reason=\""
				 << *reason << "\" WHERE nick='"
				 << row[0] << "' AND UNIX_TIMESTAMP(date_kick)=" << row[1];
		}
		mysql_free_result(res);
		if(mysql_query(&mS.db_handle, os.str().data()))
		{
			cout << os << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
			return -1;
		}
	}
	else
	{
		// nothing found, insert new data
		os.str(empty);
		os << "INSERT INTO kicklist (nick, date_kick, ip, nick_op, reason, status) VALUES ";
		os << "('" << conn->mpUser->mNick << "', NOW(), '" << conn->AddrIP() << "', '"
			 << op->mpUser->mNick << "', ";
		if(reason) os << "\"" << *reason << "\", 'message')";
		else       os << " NULL, 'drop')";
		if(mysql_query(&mS.db_handle, os.str().data()))
		{
			cout << os << endl;
			cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		}
	}
	//mysql_free_result(result);
	return 0;
}

/** search for kick record, return 1 if found, else 0 */
int cDCBanList::FindKick(cKick &kick, time_t last_s, string &ip, string &op, bool noban_only)
{
	ostringstream query;
	MYSQL_RES *result;
	MYSQL_ROW row;
	
	query << "SELECT nick, UNIX_TIMESTAMP(date_kick), ip, nick_op, reason FROM kicklist WHERE"
		 << " ip = '" << ip << "'";
	if(last_s) query << " AND UNIX_TIMESTAMP(date_kick) >= (UNIX_TIMESTAMP(NOW()) -" << last_s << ")";
	if(noban_only) query << " AND banned IS NULL";
	query << " AND nick_op ='" << op << "' ORDER BY date_kick DESC LIMIT 1";
	//cout << query.str() << endl;
	if(mysql_query(&mS.db_handle, query.str().data()))
	{
		cout << query.str() << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		return 0;
	}
	result = mysql_store_result(&mS.db_handle);
	int row_count= mysql_num_rows(result);

	if(row_count)
	{
		// fetch a row
		row = mysql_fetch_row(result);
		// fill in structure
		kick.mNick  = row[0] ? row[0] : "";
		kick.mTime  = row[1] ? atol(row[1]) : 0;
		kick.mIP    = row[2] ? row[2] : "";
		kick.mOp    = row[3] ? row[3] : "";
		kick.mReason= row[4] ? row[4] : "";
	}

	mysql_free_result(result);
	return row_count;
}

/** send banlist to connection */
int cDCBanList::GetBanList(cConnDC *conn, int list, const string *filter)
{
	ostringstream os;
	string query;
	MYSQL_RES *result;
	MYSQL_ROW row;
	
	os << "Banlist:" << endl;
	query = "SELECT * from ipbanlist ";
	if(filter)
	{
		query += "WHERE ip ='";
		query += *filter;
		query += "' OR nick_ban='";
		query += *filter;
		query += "' ";
	}
	query+= " ORDER BY ip";
	if(mysql_query(&mS.db_handle, query.data()))
	{
		cout << query << endl;
		cout << "Mysql Error: " << mysql_error( &mS.db_handle ) << endl;
		return 0;
	}
	result = mysql_store_result(&mS.db_handle);
	int row_count= mysql_num_rows(result);
	int col_count= mysql_field_count(&mS.db_handle);

	if(row_count)
	{
		while((row = mysql_fetch_row(result)))
		{
			for(int i=0; i < col_count; i++)
			{
				os << (row[i] ? row[i] : "NULL") << " ][ ";
			}
			os << endl;
		}
	}
	os << "Done.";
	mS.DCPublicHS(os.str(), conn);
	return 0;
}

};
