/***************************************************************************
                          cdcbanlist.h  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDCBANLIST_H
#define CDCBANLIST_H

#include "cdcbanrecord.h"

namespace nDirectConnect
{

/**list of bans
  *@author Daniel Muller
  */

class cConnDC;
class cServerDC;
class cKick;

enum
{
	eBT_IP = 1 << 0,
	eBT_NICK = 1 << 1,
	eBT_HOST = 1 << 2,
	eBT_NICKIP = eBT_IP|eBT_NICK
};
  
class cDCBanList {
public: 
	cDCBanList(cServerDC &serv,const string&);
	~cDCBanList();
	
	/** search for address */
	//cDCBanRecord * SearchAddr(const string&,const string &, bool, bool all=false);
	/** remove given ban from the list, if possible */
	int RemoveBan(const string &ip, const string &nick, const string &host, int method=eBT_NICKIP);
	/** add ban entry */
	//int AddBan(const string &,time_t , cConnDC *, const string &, const string &);
	/** creates empty table in database if not exists */
	int CreateTable();
	/** No descriptions */
	int FindBan(cConnDC *,cDCBanRecord &);
	/** No descriptions */
	int FindBan(const string &nick,cDCBanRecord &);
	/** removes old bans from banlists, and moves them to another table */
	int RemoveOldBans();
	/** add ban entry, ban conn, by op, for t seconds (0=perm), with reason, and user methods */
	int AddBan(const string&ip, const string&nick, const string&host, cConnDC *op, time_t,  const string &reason, int bantype, bool force=true );
	/** ads kick into a database */
	int AddKick(cConnDC *,cConnDC *, const string *);
	/** search for kick record, return 1 if found, else 0 */
	int FindKick(cKick &, time_t last_s, string &ip, string &op,bool noban_only);
  /** send banlist to connection */
  int GetBanList(cConnDC *conn, int list=eBT_IP, const string *filter=NULL);
	public: // Public attributes
	/** filename of the banlist */
	string mFileName;
	/** reference to server*/
	cServerDC &mS;
};

};

#endif
