/***************************************************************************
                          cdcbanrecord.cpp  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdcbanrecord.h"
#include <sstream>

namespace nDirectConnect
{

cDCBanRecord::cDCBanRecord(){
}
cDCBanRecord::~cDCBanRecord(){
}

/** from the fie line in format : mAddr mEnd #mStart $mNick %mOp :mCode */
cDCBanRecord::cDCBanRecord(const string &)
{
	mBanType=0;
}

/** load from string */
int cDCBanRecord::Load(const string &line)
{
	stringstream is(line);
	mEnd = 0;
	char c;
	
	is >> mAddr >> mEnd;
	if(!mAddr.size()) return 0;
	while(!is.eof())
	{
		c=' ';
		is >> c;
		if( c== ' ') break;
		switch(c)
		{
			case '#': is >> mStart; break;
			case '$': is >> mNick; break;
			case '%': is >> mOp; break;
			case ':': is >> mCode; break;
			default: break;
		}
	}
	return 1;
}

/** extraction operator */
istream &operator >>(istream &is, cDCBanRecord &br)
{
	string str; int i=1;
	while(!is.eof() && i )
	{
		getline(is,str);
		i = !br.Load(str);
	}
	return is;
}

/** insertion operator */
ostream &operator <<(ostream &os, cDCBanRecord &br)
{
	os << br.mAddr;
	if(br.mEnd > 0) os << " " << br.mEnd;
	os << " #" << br.mStart;
	if(br.mNick.size()) os << " $" << br.mNick;
	if(br.mOp.size())   os << " %" << br.mOp;
	if(br.mCode.size()) os << " :" << br.mCode;
	os << endl;
	return os;
}

/** return true if address is ip */
int cDCBanRecord::IsIP(){
	return 1;
}

/** return true if it is a host name */
int cDCBanRecord::IsHost(){
	return 0;
}

/** return tru is address is private space ip */
int cDCBanRecord::IsPriv(){
	return 0;
}
/** return tru is address is ip range subnet mask or something like that */
int cDCBanRecord::IsNet(){
	return 0;
}

};
