/***************************************************************************
                          cdcbanrecord.h  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDCBANRECORD_H
#define CDCBANRECORD_H

#include <string>
#include <iostream>

using namespace std;

namespace nDirectConnect
{

/**ban info
  *@author Daniel Muller
  */

class cDCBanRecord
{
public:
	/** default constructor */
	cDCBanRecord();
	/** from the fie line in format : mAddr mEnd #mStart $mNick %mOp :mCode */
	cDCBanRecord(const string &);
	~cDCBanRecord();
	/** extraction operator */
	friend istream &operator >>(istream &, cDCBanRecord &);
	/** insertion operator */
	friend ostream &operator <<(ostream &, cDCBanRecord &);
	/** load from string */
	int Load(const string &);
	/** return true if it is a host name */
	int IsHost();
	/** return tru is address is ip */
	int IsIP();
	/** return tru is address is ip range subnet mask or something like that */
	int IsNet();
	/** return tru is address is private space ip */
	int IsPriv();
	/** ip or host or a partial..*/
	string mAddr;
	/** start time stamp */
	unsigned mStart;
	/** end time stamp, negative means infinite - perm ban */
	unsigned mEnd;
	/** user's nick */
	string mNick;
	/** op's nick */
	string mOp;
	/** code of reason */
	string mCode;
	/** 0 unknown, 1 ip, 2 ip range, 3 host, 4 domain, 5 nick, 6kick etc... */
	int mBanType;
	/** kick/ban reason */
	string mReason;
	/** hostname */
	string mHost;
	/** how muany seconds are to be banned */
	unsigned long mTimeRest;
};

};

#endif
