/***************************************************************************
                          cdcconf.cpp  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdcconf.h"
#include "cserverdc.h"
#include <string>
using namespace std;

namespace nDirectConnect
{

cDCConf::cDCConf(const string &file, cServerDC &serv ):cConfigFile(file), mS(serv)
{
	Add(string("max_extra_regs"),max_extra_regs,50);
	Add(string("max_extra_ops"),max_extra_ops,50);
	Add(string("max_extra_admins"),max_extra_admins,500);
	Add(string("max_users"),max_users,3500);
	Add(string("min_share"),min_share,(unsigned long)1*1024);
	Add(string("min_share_reg"),min_share_reg,(unsigned long)0*1024);
	Add(string("min_share_ops"),min_share_ops,(unsigned long)0);
	Add(string("max_share"),max_share,(unsigned long)1024*1024);
	Add(string("max_share_reg"),max_share_reg,(unsigned long)10*1024*1024);
	Add(string("tban_kick"),tban_kick,300);
	Add(string("hub_name"),hub_name,string("VerliHub"));
	Add(string("hub_desc"),hub_desc,string("VerliHub"));
	Add(string("hub_host"),hub_host,string("verlihub.no-ip.com"));
	Add(string("hublist_host"),hublist_host,string("213.226.69.87"));
	Add(string("hublist_port"),hublist_port,2501);
	Add(string("max_nick"),max_nick,32u);
	Add(string("min_nick"),min_nick,3u);
	Add(string("nick_chars"),nick_chars,string("!%&()*+,-./0123456789:;=?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{}#"));
	Add(string("max_chat_msg"),max_chat_msg,256u);
	Add(string("max_chat_lines"),max_chat_lines,5);
	Add(string("db_host"),db_host,string("loclahost"));
	Add(string("db_user"),db_user,string("verlihub"));
	Add(string("db_pass"),db_pass,string(""));
	Add(string("db_data"),db_data,string("verlihub"));
	Add(string("nick_prefix"),nick_prefix,string(""));
	Add(string("listen_port"),mS.mPort,4111);
	Add(string("listen_ip"),mS.mAddr,string("0.0.0.0"));
	Add(string("timer_conn_period"), mS.timer_conn_period, 4);
	Add(string("timer_serv_period"), mS.timer_serv_period, 1);
	Add(string("nicklist_on_login"),nicklist_on_login, 1);
	Add(string("delayed_search"),delayed_search, 1);
	Add(string("delayed_myinfo"),delayed_myinfo, 1);
	Add(string("step_delay"), mS.mStepDelay, 100);
	Add(string("hub_security"), hub_security, string("VerliHub"));
	Add(string("log_level"),mS.msLogLevel, 2);
	Add(string("check_ctm"),check_ctm,1);
	Add(string("check_rctm"),check_rctm,1);
	Add(string("max_message_size"),mS.mMaxLineLength, 10240ul);
	Add(string("dns_lookup"),mS.mUseDNS, 0);
	Add(string("hide_all_kicks"),hide_all_kicks,0);
	Add(string("optimize_userlist"),optimize_userlist,0);
	Add(string("hub_owner"),hub_owner,string("unspecified_owner"));
	Add(string("int_search"),int_search,6);
	Add(string("ul_portion"),ul_portion,50);


	ostringstream varname;
	string empty;
	for(int i=0; i <10; i++)
	{
		varname.str(empty);
		varname << "redir_host" << i;
		Add(varname.str(),redir_host[i],string("czpro.no-ip.com"));
	}

	max_length[eDC_KEY]=128;
	max_length[eDC_VALIDATENICK]=64;
	max_length[eDC_MYPASS]=64;
	max_length[eDC_VERSION]=32;
	max_length[eDC_GETNICKLIST]=16;
	max_length[eDC_MYNIFO]=128;
	max_length[eDC_GETINFO]=10+max_nick;
	max_length[eDC_CONNECTTOME]=32*2*max_nick;
	max_length[eDC_MCONNECTTOME]=64;
	max_length[eDC_RCONNECTTOME]=64;
	max_length[eDC_TO]=2048;
	max_length[eDC_CHAT]=1024;
	max_length[eDC_QUIT]=64;
	max_length[eDC_OPFORCEMOVE]=512;
	max_length[eDC_KICK]=64;
	max_length[eDC_SEARCH_PAS]=256;
	max_length[eDC_SEARCH]=256;
	max_length[eDC_SR]=256;
	max_length[eDC_MSEARCH]=256;
	max_length[eDC_UNKNOWN]=8;
}

cDCConf::~cDCConf()
{
}

};
