/***************************************************************************
                          cdcconsole.h  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDCCONSOLE_H
#define CDCCONSOLE_H

#include <string>
#include "cdcbanlist.h"
#include "ctriggers.h"
#include "cobj.h"

using namespace std;

namespace nDirectConnect
{

class cConnDC;

/**command interpreter for operators
  *@author Daniel Muller
  */

class cServerDC;

class cDCConsole : public cObj
{
public:
	cDCConsole(cServerDC &);
	~cDCConsole();
	cServerDC &mS;
	/** act on op's command */
	int OpCommand(const string &, cConnDC*);
	/** act on usr's command */
	int UsrCommand(const string & , cConnDC * );
	/** get user's ip */
	int  CmdGetip(stringstream &, cConnDC *);
	/** get user's host */
	int CmdGethost(stringstream & , cConnDC * );
	/** get user's host and ip */
	int CmdGetinfo(stringstream &cmd_line , cConnDC *conn );
	/** unban ip or host */
	int CmdUnban(stringstream & cmd_line, cConnDC * conn, int unbantype = eBT_NICKIP);
	/** ban ip or host */
	int CmdBan(stringstream & cmd_line, cConnDC * conn, bool, int bantype=eBT_NICKIP);
	/** quit program */
	int CmdQuit(stringstream &, cConnDC * conn);
	/** set variable */
	int CmdSet(stringstream & cmd_line, cConnDC * conn);
	/** show alll variables along with their values */
	int CmdGetconfig(stringstream & cmd_line, cConnDC * conn);
	/** send help message corresponding to connection */
	int CmdHelp(stringstream & cmd_line, cConnDC * conn);
	/** send rules */
	int CmdRules(stringstream & cmd_line, cConnDC * conn);
	/** send faq */
	int CmdFaq(stringstream & cmd_line, cConnDC * conn);
	/** broadcast a message to pm of all */
	int CmdBroadcast(stringstream & cmd_line, cConnDC * conn,int cl_min, int cl_max);
	/** Registrations .... */
	int CmdRegNewUser (stringstream & cmd_line, cConnDC * conn);
	int CmdRegDelUser (stringstream & cmd_line, cConnDC * conn);
	int CmdRegPurge   (stringstream & cmd_line, cConnDC * conn);
	int CmdRegClass   (stringstream & cmd_line, cConnDC * conn);
	int CmdRegPasswd  (stringstream & cmd_line, cConnDC * conn);
	int CmdRegEnable  (stringstream & cmd_line, cConnDC * conn);
	int CmdRegDisable (stringstream & cmd_line, cConnDC * conn);
	int CmdRegMyPasswd(stringstream & cmd_line, cConnDC * conn);
	/** send faq */
	int CmdKick(stringstream & cmd_line, cConnDC * conn, bool);
	/** banlist */
	int CmdBanList(stringstream & cmd_line, cConnDC * conn, int bantype, bool filter=false);
	/** get list of users with given ip */
	int CmdWhoIP(stringstream & cmd_line, cConnDC * conn);
	/** make a secret user/op */
	int CmdHideMe(stringstream & cmd_line, cConnDC * conn);
	/** progressively change user limit */
	int CmdUserLimit(stringstream & cmd_line, cConnDC * conn);
	int CmdUnHideKick(stringstream &cmd_line, cConnDC *conn);
	int CmdHideKick(stringstream &cmd_line, cConnDC *conn);
	int CmdClass(stringstream &cmd_line, cConnDC *conn);
	int CmdUnGag(stringstream &cmd_line, cConnDC *conn);
	int CmdGag(stringstream &cmd_line, cConnDC *conn);
	int CmdProtect(stringstream &cmd_line, cConnDC *conn);
	int CmdReload (stringstream &cmd_line, cConnDC *conn);
private:
	cTriggers mTriggers;
};

};

#endif
