/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "cmysql.h"

namespace nMySQL {

cMySQL::cMySQL() : cObj("cMySQL")
{
	mDBHandle = new MYSQL;
	memset(mDBHandle,0, sizeof(*mDBHandle));
	if(!mysql_init(mDBHandle)) Error(0, string("Can't init mysql structure :(.: "));
}


cMySQL::~cMySQL()
{
	delete mDBHandle;
}

int cMySQL::Connect(string &host, string &user, string &pass, string &data)
{
	if(Log(1)) LogStream() << "Connecting to mysql server: "
			<< user << "@" << host << "/" << data << endl;

	mysql_options(mDBHandle,MYSQL_OPT_COMPRESS,0);
	if(!mysql_real_connect(
		mDBHandle,
		host.data(),
		user.data(),
		pass.data(),
		data.data(),0,0,0
		)
	)
		Error(1, string("Connection to mysql server failed: "));


}

/*!
    \fn cMySQL::Error()
 */
void cMySQL::Error(int level, string text)
{
	if(ErrLog(level)) LogStream() << text << mysql_error(mDBHandle) << endl;
}

};




