/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "cquery.h"

namespace nMySQL {

cQuery::cQuery(cMySQL & mysql)
	: cObj("nMySQL::cQuery"), mMySQL(mysql), mResult(NULL)
{
}

cQuery::~cQuery()
{
}

void cQuery::Clear(void)
{
	if(mResult)
	{
		mysql_free_result(mResult);
		mResult = NULL;
	}
}

int cQuery::Query()
{
	if(Log(2)) LogStream() << "Execute query ~" << mOS.str() << "~" << endl;
	if(mysql_query(mMySQL.mDBHandle, mOS.str().data()))
	{
		mMySQL.Error(2,string("Query error:"));
		return -1;
	}
	return 1;//mysql_affected_rows(mMySQL.mDBHandle);
}

int cQuery::StoreResult()
{
	mResult = mysql_store_result(mMySQL.mDBHandle);
	return mysql_num_rows(mResult);
}

MYSQL_ROW cQuery::Row()
{
	if(!mResult) return NULL;
	return mysql_fetch_row(mResult);
}

int cQuery::Cols()
{
	return mysql_num_fields(mResult);
}

};
