/***************************************************************************
                          creglist.h  -  description
                             -------------------
    begin                : Mon Jul 7 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CREGLIST_H
#define CREGLIST_H


#include <string>
using namespace std;

namespace nDirectConnect
{

/**a reg users list
  *@author Daniel Muller
  */

// forward declarations
class cConnDC;
class cServerDC;
class cRegUserInfo;

class cRegList {
public: 
	cRegList(cServerDC &serv);
	~cRegList();
	/** creates empty table in database if not exists */
	int CreateTable();
	/** find nick in reglist
		if not foud return 0
		else return 1 and fill in the reuserinfo parameter */
	int FindRegInfo(cRegUserInfo &, const string &nick);
	/** add registered user */
	int AddRegUser(const string &nick, cConnDC *op, int cl);
	/** No descriptions */
	int ChangePwd(const string &nick, const string &pwd,int);
	/** No descriptions */
	int SetVar(const string &nick, string &field, string &value);
	/** log that user logged in */
	int Login(cConnDC *conn, const string &nick);
	/** log that user logged in with wrong passwd*/
	int LoginError(cConnDC *conn, const string &nick);

protected: // Protected attributes
	/** reference to a server */
	cServerDC & mS;
};

};
#endif
