/***************************************************************************
                          creguserinfo.h  -  description
                             -------------------
    begin                : Mon Jun 16 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CREGUSERINFO_H
#define CREGUSERINFO_H

#include <string>
#include <iostream>

using namespace std;

namespace nDirectConnect
{

/**info on a registered user
  *@author Daniel Muller
  */

class cRegUserInfo
{
public: 
	cRegUserInfo();
	~cRegUserInfo();
	/** verify password - return true if ok */
	bool PWVerify(string pass);

	/** friends */
	friend ostream & operator << (ostream &, cRegUserInfo &i);
	friend istream & operator >> (istream &, cRegUserInfo &i);
	friend class cUser;
	friend class cRegList;
	
	/** nickname */
	string & GetNick();
	/** return user class */
	int getClass(){return mClass;};
private:
public: // Public attributes
	/** nickname */
	string mNick;
	/** password/hash */
	string mPasswd;
	/** crypted passwd - if mPasswd is a raw pw or a hash */
	bool mPWCrypt;
	/** */
	int mClass;
	/** time of last login */
	time_t mLoginLast;
	/** time of last error */
	time_t mErrorLast;
	/** last login ip */
	string mLoginIP;
	/** last error ip */
	string mErrorIP;
	/** can change password */
	bool mPwdChange;
	/** account enabled */
	bool mEnabled;
};

};
#endif
