/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "ctriggers.h"

namespace nDirectConnect {

cTriggers::cTriggers( nMySQL::cMySQL &mysql )
 : cConfMySQL(mysql)
{
	SetClassName("nDC::cTriggers");
	Add(string("command"),mModel.mCommand,string("+default"));
	Add(string("send_as"),mModel.mSendAs,string("Hub-Security"));
	Add(string("flags")  ,mModel.mFlags, 0);
	Add(string("def")    ,mModel.mDefinition,string("./.verlihub/default"));
	Add(string("descr")  ,mModel.mDescription,string("default trigger, you type it in chat, and a default file is print"));
	Add(string("min_class"),mModel.mMinClass,0);
	Add(string("trunc_ln")  ,mModel.mMaxLines,0);
	Add(string("trunc_len") ,mModel.mMaxSize,0);
	Add(string("delay_usr") ,mModel.mDelayUser,10);
	Add(string("delay_total") ,mModel.mDelayTotal,1);
	SetBaseTo(&mModel);
}


cTriggers::~cTriggers()
{
}

int cTriggers::LoadAll()
{
	if( StartQuery(string("SELECT * FROM file_trigger")) == -1) return 0;

	int n=0;
	PrepareNew();
	while( Load() >= 0 )
	{
		n++;
		if(Log(3)) LogStream() << "Loading :" << mData.back()->mCommand << endl;
		PrepareNew();
	}
	DeleteLast();

	EndQuery();
	return n;
}

int cTriggers::DeleteLast()
{
	if( !mData.size() ) return 0;
	SetBaseTo(&mModel);
	delete mData.back();
	mData.pop_back();
}

void cTriggers::PrepareNew()
{
	cTrigger *tr = new cTrigger;
	SetBaseTo(tr);
	mData.push_back(tr);
}

cTrigger * cTriggers::operator[](int i)
{
	if( i < 0 || i >= Size() ) return NULL;
	return mData[i];
}

};

