/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef NDIRECTCONNECTCTRIGGERS_H
#define NDIRECTCONNECTCTRIGGERS_H

#include "ctrigger.h"
#include <vector>
#include <cconfmysql.h>

using std::vector;
using nConfig::cConfMySQL;

namespace nDirectConnect {

/**
the vector of triggers, with load, reload, save functions..

@author Daniel Muller
*/
class cTriggers : public cConfMySQL
{
public:
	cTriggers(nMySQL::cMySQL &mysql);
	~cTriggers();
	void Empty();
	int LoadAll();
	int Size(){ return mData.size();}
	void PrepareNew();
	int DeleteLast();
	cTrigger * operator[](int );
private:
	cMySQL mMySQL;
	vector<cTrigger *> mData;
	// a model of a trigger
	cTrigger mModel;
};

};

#endif
