/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu May  8 17:34:45 CEST 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <stdlib.h>
#include "cserverdc.h"
#include <sstream>
#include <signal.h>

using namespace std;
using namespace nDirectConnect;

void mySigPipeHandler(int i)
{
	signal(SIGPIPE,mySigPipeHandler);
	cout << "Received SIGPIPE, ignoring it, " << i << endl;
}

void mySigIOHandler(int i)
{
	signal(SIGIO  ,mySigIOHandler  );
	cout << endl << "Received SIGIO, ignoring it, " << i << endl;
}

void mySigQuitHandler(int i)
{
	cout << "Received a " << i << " signal, quiting";
	exit(0);
}

int main(int argc, char *argv[])
{ //zmena na verlibe
	try
	{
		cServerDC server;
		int port=0;
		if(argc > 1)
		{
			stringstream arg(argv[1]);
			arg >> port;
		}

		signal(SIGPIPE,mySigPipeHandler);
		signal(SIGIO  ,mySigIOHandler  );
		signal(SIGQUIT,mySigQuitHandler);
	
		//server.CfgSetHubName(hubname);
		
		server.listen(port);
		server.run(); // run the main loop until it stops itself
	}
	catch(const char * e){cout << "Caught error:" << e << endl;return 1;}
	catch(...){cout << "Unknown  error " << endl;return 1;}
	return 0;
}
