/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef STRINGHASHMAP_H
#define STRINGHASHMAP_H

#include <string>
#include <ext/hash_map>

using namespace std;
using namespace __gnu_cxx;


/** string comparisson structure */
struct eEqString{bool operator()(const std::string &s1, const std::string &s2) const{return s1 == s2;}};

/** hashing structure */
struct hHashStr
{
	static hash<const char *> msHash;
	size_t operator() (const std::string &s) const {return msHash(s.data());}
};

/** std::string hash map */
#define tStringHashMap(T_DATA) hash_map<std::string,T_DATA, hHashStr, eEqString>

#endif
